#include "define.h"
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <io.h>
#include <stdarg.h>
#include "globals.h"
#include "util_bw.h"
#include "mouse.h"

#define LOC_MK_FP(seg,off) ((void *)(((unsigned long)(seg)<<16)|(unsigned long)(off)))

extern int GrTextHeight(void);
extern byte *Boolean(int);
extern unsigned install43(void);
extern unsigned install25(void);
extern void _cdecl rbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl fbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl video_wr(unsigned,unsigned,int,int);
extern void _fastcall bvideo(int);
extern int detect_vga(void);
extern int detect_ega(void);

extern int Y_max;
extern char kbd_status;
extern unsigned char last_line;

extern int graphics_mode;
extern int GrTextMaxY;
extern int ms_status;
extern int current_background;
extern int current_foreground;
extern unsigned scr_seg;
extern int max_window_ofs;
extern int max_x_coord;
extern int max_y_coord;
extern int min_x_coord;
extern int min_y_coord;
extern int carriage_return_ofs;
extern int no_retrace_wait;
extern int original_crtmode;
extern int ega_found;
extern int vga_found;
extern int mda_found;
extern int cga_found;
extern int dv_found;
extern int dos_major_version;
extern int dos_minor_version;
extern int yield_idle_time;
extern int windoze_found;
extern int dv_major_version;
extern int dv_minor_version;
extern int win_major_version;
extern int win_minor_version;
extern unsigned long low_deferred;
extern unsigned long hi_deferred;
extern int deferred_update;

void wf_video_status(int x,int y)
{
    wf_gotoxy(x,y);
    if (dv_found) {
	wf_printf("DESQview %d.%d detected.\r\n",
	    dv_major_version,
	      dv_minor_version);
        return;
    }
    if (windoze_found) {
        wf_printf("MS-Windows %d.%d detected.\r\n",
            win_major_version,
              win_minor_version);
        return;
    }
}

void cleanup(unsigned numrows,unsigned last_row)
{
    scr_numrows_minus1  = numrows;
    scr_numrows = numrows + 1;
    last_line += (scr_numrows - last_row);
    shape_cursor(SKINNY_CURSOR);
    if (ms_status)
        ms_show();
}

unsigned BiosScrLen(void)
{
    union REGS regs;

    regs.x.ax = 0x1130;
    regs.x.bx = 0x0000;
    int86(0x10,&regs,&regs);                 // Get number of rows
    return( ((unsigned) regs.h.dl) );
}

void set43(int ymax)
{
    unsigned last_row, scr_len;

    if ((!ega_found)&&(!vga_found))
	return;
    if (graphics_mode) {
        if (ms_status)
            ms_hide();
        last_row = scr_numrows;
        scr_len = ((ymax + 1) / GrTextHeight()) - 1;
        goto CleanUpExit;
    }
    if (ms_status)
        ms_hide();
    last_row = scr_numrows;
    scr_len = install43();
CleanUpExit:
    cleanup(scr_len,last_row);
}

void reset43(void)
{
    unsigned last_row, scr_len;

    if ((!ega_found)&&(!vga_found))
	return;
    if (graphics_mode) {
        set43(Y_max);
        return;
    }
    if (ms_status)
        ms_hide();
    last_row = scr_numrows;
    scr_len = install25();
    cleanup(scr_len,last_row);
}

int detect_win(void)
{
    union REGS regs;

    regs.x.ax = 0x1600;
    int86(0x2F,&regs,&regs);
    if ((!regs.h.al) || (regs.h.al == 0x80))
        return(0);
    win_major_version = regs.h.al;
    win_minor_version = regs.h.ah;
    return(1);
}

int detect_dv(void)
{
    union REGS regs;
    struct SREGS sregs;

    regs.x.ax = 0x3000;
    int86(0x21,&regs,&regs);
    dos_major_version = regs.h.al;
    dos_minor_version = regs.h.ah;
    segread(&sregs);
    sregs.es = scr_seg;
    regs.x.di = 0;
    regs.x.cx = 0x4445;
    regs.x.dx = 0x5351;
    regs.x.ax = 0x2b01;
    intdosx(&regs,&regs,&sregs);
    if (regs.h.al == 0xff)
	return(0);
    dv_major_version = regs.h.bh;
    dv_minor_version = regs.h.bl;
    regs.x.ax = 0xfe00;
    int86x(0x10,&regs,&regs,&sregs);
    scr_ptr = LOC_MK_FP(sregs.es,regs.x.di);
    return(1);
}

void wf_initvideo(void)
{
    union REGS regs;
    unsigned last_row;
    unsigned long vbeg;

    ms_status =
      cga_found =
        mda_found =
          vga_found =
            ega_found =
	      dv_found =
                dos_major_version =
                  yield_idle_time =
                    windoze_found =
	              deferred_update = 0;
    regs.x.ax = 0x0f00;
    int86(0x10,&regs,&regs);
    original_crtmode =
       crtmode = regs.h.al;
    if ((crtmode!=3)&&(crtmode!=7)) {
	crtmode =
	   regs.x.ax = 3;
	int86(0x10,&regs,&regs);
    }
    scr_seg = 0xb800;
    if (crtmode == 7) {
	mda_found = 1;
	scr_seg = 0xb000;
    }
    else {
	if (!(vga_found = detect_vga()))
	    ega_found = detect_ega();
    }
    scr_ptr = LOC_MK_FP(scr_seg,0);
    dv_found = detect_dv();
    if (!dv_found)
        windoze_found = detect_win();
    if ((dos_major_version>9) || (windoze_found))
        yield_idle_time = TRUE;
    scr_seg = FP_SEG(scr_ptr);
    if (mda_found) {
        original_length =
            scr_numrows = 25;
        last_row = scr_numrows;
        scr_numrows_minus1 = original_length - 1;
        max_y_coord = original_length;
        last_line = 24;
        no_retrace_wait =
          ms_status = FALSE;
            mouse_active = FALSE;
    }
    else {
	if ((vga_found)||(ega_found)) {
	    if (crtmode == 3) {
		original_length = BiosScrLen() + 1;
		if ((original_length > 25) && (original_length < 101)) {
		    last_row = scr_numrows;
		    scr_numrows_minus1 = original_length - 1;
		    max_y_coord =
		      scr_numrows = original_length;
		    last_line = scr_numrows - last_row + last_line;
		}
	    }
	}
	else {
	    cga_found = 1;
	    if (!dv_found) {
		no_retrace_wait = FALSE;
		real_time(&vbeg);
		while (elapsed(vbeg) < 15L) {
		    if (!((inportb(0x03DA)) & 0x0008))
			goto Vcolor;
		}
	    }
	}
        ms_status = ms_init(0,0,0,0);
        if (ms_status) {
            ms_gotoxy(0,0);
            ms_read(&mouse_x,&mouse_y,&mouse_button);
            mouse_active = TRUE;
        }
    }
    no_retrace_wait = 1;
Vcolor:
    set_color(7,0);
    scr_numcols_minus1 = 79;
    scr_numcols =
        original_width = 80;
    max_x_coord = 80;
    return;
}

void Yield_Time(int t)
{
    union REGS regs;

    if (dv_found) {
	regs.x.ax = 0x1000;
	int86(0x15,&regs,&regs);
        return;
    }
    if (yield_idle_time) {
        regs.x.ax = 0x1680;
        int86(0x2F,&regs,&regs);
        return;
    }
    delay(t);
}

void WinDelay(int t)
{
    longint stime, th;

    if (t<1500) {
        delay(t);
        return;
    }
    real_time(&stime);
    th = (longint)((t / 10) - 1);
    while (TRUE) {
        if (elapsed(stime) >= th)
            return;
        Yield_Time(15);
    }
}
